#include "game.h"
#include "libmy/key.h"
#include "libmy/adrv.h"
#include "libmy/gbfs.h"
#include "libmy/snd.h"
#include "libmy/mode3.h"
#include "libmy/spr.h"
#include "res.h"


//---------------------------------------------------------------------------
ST_GAME Game;


//---------------------------------------------------------------------------
EWRAM_CODE void GameInit()
{
	_Memset(&Game, 0x00, sizeof(ST_GAME));

	Game.state = GAME_INIT;
	Game.key   = 0xffff;
}
//---------------------------------------------------------------------------
EWRAM_CODE void GameExec()
{
	switch(Game.state)
	{
	case GAME_INIT:
		SndSetData(SND_ID_BGM, (u8*)&snd_hee_raw, *(u32*)&snd_hee_raw_size, 0, FALSE);
		Game.state = GAME_RESET;
		break;

	case GAME_RESET:
		Game.heeCnt = 0;
		Game.state  = GAME_WAIT;
		break;

	case GAME_WAIT: ;
		u16 key = KeyGetTrg();

		if(key & KEY_A)
		{
			Game.state = GAME_SND;
		}
		else if(key & KEY_B)
		{
			Game.state = GAME_RESET;
		}
		break;

	case GAME_SND:
		if(Game.heeCnt < 20)
		{
			Game.heeCnt++;
			SndPlay(SND_ID_BGM);
		}
		Game.state  = GAME_WAIT;
		break;

	default:
		SystemError("[Err] GameExec State");
		break;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void GameDraw()
{
	u16 key = KeyGetCnt();

	// O̓͂ƈAʂXV܂iKȏ
	if(Game.key != key)
	{
		if(key & KEY_A)
		{
			Mode3DrawFull((u16*)&btn_onBitmap);
		}
		else
		{
			Mode3DrawFull((u16*)&btn_offBitmap);
		}

		Game.key = key;
	}


	char buf[16];
	_Sprintf(buf, "%2d", Game.heeCnt);

	u16 tile1 = (buf[0] == ' ') ? 0 : (buf[0] - '0' + 1) * 32;
	u16 tile2 = (buf[1] == ' ') ? 0 : (buf[1] - '0' + 1) * 32;

	SprDraw(0, 20 +  0, 100, tile1);
	SprDraw(1, 20 + 32, 100, tile2);
}
