#include "irq_arm.h"
#include "libmy/intr_arm.h"
#include "libmy/debug.h"
#include "libmy/snd.h"
#include "libmy/adrv.h"


//---------------------------------------------------------------------------------
EWRAM_CODE void IrqInit()
{
	// Vblank
	IntrSetHandler(INTR_VBLANK, IrqVblank);
	IntrSetEnable(IRQ_VBLANK);

	// Vcount
//	IntrSetHandler(INTR_VCOUNT, IrqVcount);
//	IntrSetEnable(IRQ_VCOUNT);

	// Timer
//	IntrSetHandler(INTR_TIMER3, IrqTimer3);
//	IntrSetEnable(IRQ_TIMER3);
}
//---------------------------------------------------------------------------------
IWRAM_CODE void IrqTimer3()
{
	AdrvIntr();
}
//---------------------------------------------------------------------------------
IWRAM_CODE void IrqVcount()
{
	// EMPTY
}
//---------------------------------------------------------------------------------
IWRAM_CODE void IrqVblank()
{
//	DebugIntr();

	SndBgmIntr();
	SndSeIntr();

	REG_IRQ_WAITFLAGS |= IRQ_VBLANK;
}
