#include "dma_arm.h"


//---------------------------------------------------------------------------
ST_DMA Dma ALIGN(4);


//---------------------------------------------------------------------------
EWRAM_CODE void DmaInit()
{
	_Memset(&Dma, 0x00, sizeof(ST_DMA));
}
//---------------------------------------------------------------------------
IWRAM_CODE void DmaEnqueue(u32* src, u32* dst, u16 size)
{
	Dma.chain[Dma.reserveNum].src  = src;
	Dma.chain[Dma.reserveNum].dst  = dst;
	Dma.chain[Dma.reserveNum].mode = size | (DMA_SRC_INC | DMA_DST_INC | DMA16 | DMA_ENABLE);
	Dma.reserveNum++;

	Dma.reserveNum &= (MAX_DMA_CHAIN_CNT - 1);
}
//---------------------------------------------------------------------------
IWRAM_CODE void DmaEnqueueFix(u32* src, u32* dst, u16 size)
{
	Dma.chain[Dma.reserveNum].src  = src;
	Dma.chain[Dma.reserveNum].dst  = dst;
	Dma.chain[Dma.reserveNum].mode = size | (DMA_SRC_FIXED | DMA_DST_INC | DMA16 | DMA_ENABLE);
	Dma.reserveNum++;

	Dma.reserveNum &= (MAX_DMA_CHAIN_CNT - 1);
}
//---------------------------------------------------------------------------
IWRAM_CODE void DmaTransfer()
{
	while(Dma.chain[Dma.execNum].mode != 0)
	{
		// while (REG_DMA3CNT & DMA_ENABLE) {}
		REG_DMA3SAD = (u32)Dma.chain[Dma.execNum].src;
		REG_DMA3DAD = (u32)Dma.chain[Dma.execNum].dst;
		REG_DMA3CNT = (u32)Dma.chain[Dma.execNum].mode;

		Dma.chain[Dma.execNum].mode = 0;
		Dma.execNum++;

		Dma.execNum &= (MAX_DMA_CHAIN_CNT - 1);
	}
}
