#include "spr.h"
#include "gbfs.h"
#include "dma_arm.h"
#include "../res.h"


//---------------------------------------------------------------------------
ST_SPR    Spr;
ST_SPRITE SprCur;

// ../libgba/common.c
extern u32 dummy;

//---------------------------------------------------------------------------
EWRAM_CODE void SprInit()
{
	_Memset(&Spr, 0x00, sizeof(ST_SPR));

	SprInitDat();
	SprInitPal();
	SprInitOam();

	REG_DISPCNT |= (OBJ_ON | OBJ_1D_MAP);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprInitDat()
{
	s16 i;
	u16* adr = BITMAP_OBJ_BASE_ADR;
//	u16* adr = OBJ_BASE_ADR;

	for(i=0; i<spr_numTilesLen/2; i++)
	{
		adr[i] = spr_numTiles[i];
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprInitPal()
{
	s16 i;

	for(i=0; i<16; i++)
	{
		OBJ_COLORS[i] = spr_numPal[i];
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprInitOam()
{
	s16 i;

	for(i=0; i<3; i++)
	{
		ST_SPRITE* pOam = (ST_SPRITE*)OAM + i;

		pOam->attr0 = (160 & 0x00ff) | ATTR0_COLOR_16 | ATTR0_TALL;
		pOam->attr1 = (240 & 0x01ff) | ATTR1_SIZE_64;
		pOam->attr2 = (0) | ATTR2_PRIORITY(0);
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprClean()
{
	REG_DMA3SAD = (u32)&dummy;
	REG_DMA3DAD = (u32)OAM;
	REG_DMA3CNT = (u32)sizeof(ST_SPRITE) * 128 / 2 | (DMA_SRC_FIXED | DMA_DST_INC | DMA16 | DMA_ENABLE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprUpdate()
{
/*
	if(Spr.isDraw == TRUE)
	{
		ST_SPRITE* pOam = (ST_SPRITE*)OAM;

		pOam->attr0 = SprCur.attr0;
		pOam->attr1 = SprCur.attr1;
		pOam->attr2 = SprCur.attr2;

		Spr.isDraw = FALSE;
	}
*/
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprDraw(u16 num, u16 x, u16 y, u16 tile)
{
	// TODO {͒ڏ܂Aobt@ʂ

	ST_SPRITE* pOam = (ST_SPRITE*)OAM + num;

	pOam->attr0 = (y & 0x00ff) | ATTR0_COLOR_16 | ATTR0_TALL;
	pOam->attr1 = (x & 0x01ff) | ATTR1_SIZE_64;
	pOam->attr2 = (512+tile) | ATTR2_PRIORITY(0);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetVerti(s16 ofsY)
{
	Spr.ofsY = ofsY;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetHoriz(s16 ofsX)
{
	Spr.ofsX = ofsX;
}
