#ifndef __SPR_H__
#define __SPR_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "../libgba/gba.h"

//---------------------------------------------------------------------------


//---------------------------------------------------------------------------

typedef struct {
	u16 attr0;
	u16 attr1;
	u16 attr2;
	u16 attr3;
} ST_SPRITE;


typedef struct {
	u32 attr01;
	u32 attr23;
} ST_SPRITE32;


typedef struct {
	bool isDraw;

	s16  cnt;
	s16  ofsX;
	s16  ofsY;
} ST_SPR;


//---------------------------------------------------------------------------
EWRAM_CODE void SprInit();
EWRAM_CODE void SprInitDat();
EWRAM_CODE void SprInitPal();
EWRAM_CODE void SprInitOam();
EWRAM_CODE void SprClean();
EWRAM_CODE void SprUpdate();
EWRAM_CODE void SprDraw(u16 num, u16 x, u16 y, u16 tile);

EWRAM_CODE void SprSetCur(u16 num, s16 x, s16 y);
EWRAM_CODE void SprSetVerti(s16 ofsY);
EWRAM_CODE void SprSetHoriz(s16 ofsX);


#ifdef __cplusplus
}
#endif
#endif
